#-*-coding:utf-8-*-
import tkinter
import tkinter.font as tkFont
import tools
import readconf
import os
import codecs
import shutil
import tkinter.messagebox as tkMessageBox
#全局变量
wordfile="words.txt"#单词数据文件
softname="龙龙记单词V1.0"
bgcolor='#996699'#界面背景色
fgcolor='#CCCCAA'#界面前景色
txtbgcolor='#993366'#文本框背景色
txtfgcolor='#FFFF66'#文本框前景色

#功能函数
def getWordNum():
    global V
    passnum=tools.getPassNumber()
    V.set(str(passnum[0])+"/"+str(passnum[1]))
def changeColor(btnStart2a,btnModify,btnRecent,btnCom,lblAssis,txtInput,txtInput1,frmInput,frmExam,lblInput,lblInput1,btnInput,lblExam,lblExam1,lblExam2,lblOpA,lblOpB,lblOpC,lblOpD,btnStart,btnStart1,btnStart2,btnStart3,btnStart4,btnStart5,btnA,btnB,btnC,btnD,lblResu,lblResu1,btnInput1):#更换配色方案
    global bgcolor
    global fgcolor
    global txtbgcolor
    global txtfgcolor
    #界面背景色
    rcol=['#996699','#333333','darkblue','#FF99CC','#99AA99','#006699','#AAAAAA','white']
    #界面前景色
    lcol=['#CCCCAA','#CCCCCC','yellow','#993399','#AA00AA','#CCCC00','#333333','black']
    #文本框背景色
    bcol=['#993366','#333333','blue','#993399','#AAAAAA','#006699','#CC9966','white']
    #文本框前景色
    fcol=['#FFFF66','#CCCCCC','yellow','#FFFF99','#FFFF33','#FFCCCC','#333333','black']
    lpo=lcol.index(fgcolor)
    rpo=rcol.index(bgcolor)
    bpo=bcol.index(txtbgcolor)
    fpo=fcol.index(txtfgcolor)
    fgcolor=lcol[(lpo+1)%len(lcol)]
    bgcolor=rcol[(rpo+1)%len(rcol)]
    txtbgcolor=bcol[(bpo+1)%len(bcol)]
    txtfgcolor=fcol[(fpo+1)%len(fcol)]
    frmInput["background"]=rcol[(rpo+1)%len(rcol)]
    frmExam["background"]=rcol[(rpo+1)%len(rcol)]
    txtInput["background"]=bcol[(bpo+1)%len(bcol)]
    txtInput1["background"]=bcol[(bpo+1)%len(bcol)]
    txtInput["foreground"]=fcol[(fpo+1)%len(fcol)]
    txtInput1["foreground"]=fcol[(fpo+1)%len(fcol)]
    widgetlist=[btnStart2a,btnModify,btnRecent,btnCom,lblAssis,lblInput,lblInput1,btnInput,lblExam,lblExam2,btnStart,btnStart1,btnStart2,btnStart3,btnStart4,btnStart5,btnA,btnB,btnC,btnD,lblResu,lblResu1,btnInput1]
    for ii in widgetlist:
        ii["background"]=rcol[(rpo+1)%len(rcol)]
        ii["foreground"]=lcol[(lpo+1)%len(lcol)]
    optlist=[lblOpA,lblOpB,lblOpC,lblOpD,lblExam1]
    for kk in optlist:
        kk["background"]=rcol[(rpo+1)%len(rcol)]
        kk["foreground"]=fcol[(fpo+1)%len(fcol)]

def bakeData():#备份词库
    if os.path.exists("bake/words.db"):
        os.remove("bake/words.db")
        shutil.copy2("words.db","bake/words.db")
    else:
        shutil.copy2("words.db","bake/words.db")
    tkMessageBox.showinfo("消息","词库备份成功！")
def showerror():#显示错误信息
    ls=[]
    ls=tools.getError()
    strls=""
    if ls!=None:
        for i in range(0,len(ls)):
            strls=strls+str(i)+","+ls[i]
        tkMessageBox.showinfo("错误单词",strls)
def aboutThis():
    tkMessageBox.showinfo("关于",softname+"\n\n一款跨平台记单词软件\n\n作者:IT小小龙\n\n个人博客：http://blog.sina.com.cn/buduanqs\n电子邮箱：long5092@126.com\n\n")
def changePosi(lblwd,exa,exb,exc,exd):#修改对应配置项
    temp=readconf.getConfDict()['ShowWords']
    if temp=='1':
        readconf.writeConf('ShowWords',0)
    elif temp=='0':
        readconf.writeConf('ShowWords',1)
    exams(lblwd,exa,exb,exc,exd)
def getParamsDict():#得到配置列表
    paraDict=readconf.getConfDict()
    return paraDict
def exams(lblwd,exa,exb,exc,exd):#实现单词解释变换位置
    if getParamsDict()['ShowWords']=='1':#显示单词，选择解释
        examWords(lblwd,exa,exb,exc,exd)
    else:#显示解释，选择单词
        examExpl(lblwd,exa,exb,exc,exd)
def examExpl(lblwd,exa,exb,exc,exd):#测试解释
    global V
    lblwd['text']=tools.getExpl()#动态赋值属性
    wd=lblwd['text']
    if wd!="待测目标":
        exlist=tools.getWords(wd)#随机赋值给解释
        if exlist!=0:
            exa['text']="A:  "+exlist[0]
            exb['text']="B:  "+exlist[1]
            exc['text']="C:  "+exlist[2]
            exd['text']="D:  "+exlist[3]
    passnum=tools.getPassNumber()
    V.set(str(passnum[0])+"/"+str(passnum[1]))        
def examWords(lblwd,exa,exb,exc,exd):#开始测试
    global V    
    lblwd['text']=tools.getWord()#动态赋值属性
    wd=lblwd['text']
    if wd!="待测目标":
        exlist=tools.getExpls(wd)#随机赋值给解释
        if exlist!=0:
            exa['text']="A:  "+exlist[0]
            exb['text']="B:  "+exlist[1]
            exc['text']="C:  "+exlist[2]
            exd['text']="D:  "+exlist[3]
    passnum=tools.getPassNumber()
    V.set(str(passnum[0])+"/"+str(passnum[1]))     
def insertDB(wd,exp):#插入数据库
    str=wd.get()+"#"+exp.get()
    tools.insertData(str)
    wd.delete(0,tkinter.END)
    exp.delete(0,tkinter.END)
def checkA(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#检查A是否正确
    global V
    wd=lblExam1['text']
    exp=lblOpA['text']
    result=tools.checkTrue(wd,exp,getParamsDict())
    exams(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD)
    passnum=tools.getPassNumber()
    V.set(str(passnum[0])+"/"+str(passnum[1]))
def checkB(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#检查B是否正确
    global V
    wd=lblExam1['text']
    exp=lblOpB['text']
    result=tools.checkTrue(wd,exp,getParamsDict())
    exams(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD)
    passnum=tools.getPassNumber()
    V.set(str(passnum[0])+"/"+str(passnum[1]))    
def checkC(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#检查C是否正确
    global V
    wd=lblExam1['text']
    exp=lblOpC['text']
    result=tools.checkTrue(wd,exp,getParamsDict())  
    exams(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD)  
    passnum=tools.getPassNumber()
    V.set(str(passnum[0])+"/"+str(passnum[1]))                
def checkD(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#检查D是否正确
    global V
    wd=lblExam1['text']
    exp=lblOpD['text']
    result=tools.checkTrue(wd,exp,getParamsDict())
    exams(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD)
    passnum=tools.getPassNumber()
    V.set(str(passnum[0])+"/"+str(passnum[1]))  
def showAssis(txtin,lblas):#代码提示
    lblas['text']=tools.getSimilarWord(txtin.get())
#快捷键处理区域
def assishandler(event,txtin,lblas):#单词提示
    showAssis(txtin,lblas)#显示单词提示
def assisHotKey(function,txtin,lblas):
    return lambda event,txtin=txtin,lblas=lblas:function(event,txtin,lblas)
def insertDBhandler(event,wd,exp):#回车事件
    insertDB(wd,exp)
    wd.focus()
def insertDBHotKey(function,wd,exp):#回车事件
    return lambda event,wd=wd,exp=exp:function(event,wd,exp)
def checkAhandler(event,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#字母a事件
    checkA(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD)
def checkAHotKey(function,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#字母a事件
    return lambda event,ex=lblExam1,opa=lblOpA,opb=lblOpB,opc=lblOpC,opd=lblOpD:function(event,ex,opa,opb,opc,opd)
def checkBhandler(event,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#字母b事件
    checkB(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD)    
def checkBHotKey(function,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#字母b事件
    return lambda event,ex=lblExam1,opa=lblOpA,opb=lblOpB,opc=lblOpC,opd=lblOpD:function(event,ex,opa,opb,opc,opd)#主窗体
def checkChandler(event,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#字母c事件
    checkC(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD)    
def checkCHotKey(function,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#字母c事件
    return lambda event,ex=lblExam1,opa=lblOpA,opb=lblOpB,opc=lblOpC,opd=lblOpD:function(event,ex,opa,opb,opc,opd)
def checkDhandler(event,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#字母d事件
    checkD(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD)    
def checkDHotKey(function,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD):#字母d事件
    return lambda event,ex=lblExam1,opa=lblOpA,opb=lblOpB,opc=lblOpC,opd=lblOpD:function(event,ex,opa,opb,opc,opd)
#主窗体
def getWindow():#画窗体
    global ft
    global V
    global bgcolor
    global fgcolor
    global txtbgcolor
    global txtfgcolor
    if os.path.exists("wrongwords.txt"):
        os.remove("wrongwords.txt")    
    root=tkinter.Tk()#窗体
    ft=tkFont.Font(root,family='Monospace',weight=tkFont.BOLD,size=16)#字体
    #标题栏
    root.title(softname)
    root.resizable(0,0)
    #root.attributes("-type")
    #root.attributes("-alpha",0.85)
    #单词录入区域
    frmInput=tkinter.Frame(root,bg=bgcolor,borderwidth=1,relief=tkinter.GROOVE,width=1300,height=200)
    lblInput=tkinter.Label(frmInput,bg=bgcolor,fg=fgcolor,text="请录入要测试的单词:",font=ft)
    lblInput.place(relx=0.05,rely=0.1)
    txtInput=tkinter.Entry(frmInput,bg=txtbgcolor,fg=txtfgcolor,font=ft,width=20)
    txtInput.place(relx=0.25,rely=0.1)
    lblAssis=tkinter.Label(frmInput,bg=txtbgcolor,fg=txtfgcolor,font=ft,text="hi")
    lblAssis.place(relx=0.5,rely=0.1)
    txtInput.bind('<KeyRelease>',assisHotKey(assishandler,txtInput,lblAssis))
    lblInput1=tkinter.Label(frmInput,bg=bgcolor,fg=fgcolor,text="请录入单词的简要释义:",font=ft)
    lblInput1.place(relx=0.05,rely=0.38)
    txtInput1=tkinter.Entry(frmInput,bg=txtbgcolor,fg=txtfgcolor,font=ft,width=50)
    txtInput1.place(relx=0.25,rely=0.38)
    txtInput1.bind('<Return>',insertDBHotKey(insertDBhandler,txtInput,txtInput1))
    btnInput=tkinter.Button(frmInput,bg=bgcolor,fg=fgcolor,text="提交(Enter)",font=ft,width=10,command=lambda:insertDB(txtInput,txtInput1))
    btnInput.place(relx=0.79,rely=0.36)
    btnRecent=tkinter.Button(frmInput,bg=bgcolor,fg=fgcolor,text="查看所有单词",font=ft,command=lambda:tools.getRecent())
    btnRecent.place(relx=0.05,rely=0.65)
    btnModify=tkinter.Button(frmInput,bg=bgcolor,fg=fgcolor,text="修改单词信息",font=ft,command=lambda:tools.changeWords())
    btnModify.place(relx=0.2,rely=0.65)    
    #内置记事本按钮
    frmInput.pack(side=tkinter.TOP)
    #单词测试区域
    frmExam=tkinter.Frame(root,bg=bgcolor,borderwidth=1,relief=tkinter.GROOVE,width=1300,height=395)
    lblExam=tkinter.Label(frmExam,bg=bgcolor,fg=fgcolor,text="随机测试:",font=ft)
    lblExam.place(relx=0.05,rely=0.2)
    lblExam1=tkinter.Label(frmExam,bg=bgcolor,fg=txtfgcolor,text="待测目标",font=ft)
    lblExam1.place(relx=0.2,rely=0.2)
    lblExam2=tkinter.Label(frmExam,bg=bgcolor,fg=fgcolor,text="选项区域:",font=ft)
    lblExam2.place(relx=0.05,rely=0.3)
    lblOpA=tkinter.Label(frmExam,bg=bgcolor,fg=txtfgcolor,text="选项A",font=ft)
    lblOpA.place(relx=0.2,rely=0.3)
    lblOpB=tkinter.Label(frmExam,bg=bgcolor,fg=txtfgcolor,text="选项B",font=ft)
    lblOpB.place(relx=0.2,rely=0.4)
    lblOpC=tkinter.Label(frmExam,bg=bgcolor,fg=txtfgcolor,text="选项C",font=ft)
    lblOpC.place(relx=0.2,rely=0.5)
    lblOpD=tkinter.Label(frmExam,bg=bgcolor,fg=txtfgcolor,text="选项D",font=ft)
    lblOpD.place(relx=0.2,rely=0.6)
    btnStart=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text="开始测试",font=ft,command=lambda:exams(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD))
    btnStart.place(relx=0.07,rely=0.07)
    btnStart.focus()
    btnStart1=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text="变换位置",font=ft,command=lambda:changePosi(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD))
    btnStart1.place(relx=0.19,rely=0.07)
    btnStart2=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text="错误信息",font=ft,command=showerror)
    btnStart2.place(relx=0.31,rely=0.07)
    btnStart2a=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text="导入词库",font=ft,command=lambda:tools.importWords())
    btnStart2a.place(relx=0.43,rely=0.07)    
    btnStart3=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text="导出词库",font=ft,command=lambda:tools.exportWords())
    btnStart3.place(relx=0.55,rely=0.07)         
    btnStart4=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text="备份词库",font=ft,command=bakeData)
    btnStart4.place(relx=0.67,rely=0.07)
    btnStart5=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text='关于"龙龙记单词"',font=ft,command=aboutThis)
    btnStart5.place(relx=0.79,rely=0.07)       
    btnA=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text=" "*5+"A(F1)"+" "*5,font=ft,command=lambda:checkA(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD))
    btnA.place(relx=0.1,rely=0.72)
    btnB=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text=" "*5+"B(F2)"+" "*5,font=ft,command=lambda:checkB(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD))
    btnB.place(relx=0.3,rely=0.72)
    btnC=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text=" "*5+"C(F3)"+" "*5,font=ft,command=lambda:checkC(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD))
    btnC.place(relx=0.5,rely=0.72)
    btnD=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text=" "*5+"D(F4)"+" "*5,font=ft,command=lambda:checkD(lblExam1,lblOpA,lblOpB,lblOpC,lblOpD))
    btnD.place(relx=0.7,rely=0.72)
    lblResu=tkinter.Label(frmExam,bg=bgcolor,fg=fgcolor,text="测试通过率:",font=ft)
    lblResu.place(relx=0.1,rely=0.88) 
    btnCom=tkinter.Button(frmExam,bg=bgcolor,fg=fgcolor,text="修改下限",font=ft,command=lambda:tools.changeLimit())
    btnCom.place(relx=0.38,rely=0.86)
    V=tkinter.StringVar()
    V.set("0/0")
    getWordNum()#设置已通过的单词数
    lblResu1=tkinter.Label(frmExam,bg=bgcolor,fg=fgcolor,textvariable=V,font=ft)
    lblResu1.place(relx=0.26,rely=0.88)     
    root.bind('<F1>',checkAHotKey(checkAhandler,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD))
    root.bind('<F2>',checkBHotKey(checkBhandler,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD))  
    root.bind('<F3>',checkAHotKey(checkChandler,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD)) 
    root.bind('<F4>',checkAHotKey(checkDhandler,lblExam1,lblOpA,lblOpB,lblOpC,lblOpD))
    frmExam.pack(side=tkinter.TOP)
    btnInput1=tkinter.Button(frmInput,bg=bgcolor,fg=fgcolor,text="更换配色方案",font=ft,width=10,command=lambda:changeColor(btnStart2a,btnModify,btnRecent,btnCom,lblAssis,txtInput,txtInput1,frmInput,frmExam,lblInput,lblInput1,btnInput,lblExam,lblExam1,lblExam2,lblOpA,lblOpB,lblOpC,lblOpD,btnStart,btnStart1,btnStart2,btnStart3,btnStart4,btnStart5,btnA,btnB,btnC,btnD,lblResu,lblResu1,btnInput1))
    btnInput1.place(relx=0.79,rely=0.08)
    root.mainloop()#窗体循环
def getData():#读取数据文件
    fp=codecs.open(wordfile,"r",'utf-8')
    ls=fp.readlines()
    for word in ls:
        word=word[:-1]#去掉换行符
        #print word
        tools.insertData(word)#插入数据库
    fp.close()
def main():#主引导函数
    getData()#从文件读取单词数据    
    getWindow()#测试窗口
main()



