#-*-coding:utf-8-*-
import sqlite3  
import readconf
def changeWords(id,wd,exp):#修改单词
    if len(wd)==0 and len(exp)==0:#不做任何修改
        return
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()    
    if len(wd)==0:#直接修改解释
        curs.execute("update words set expl='"+exp+"' where id="+str(id))
        conn.commit()
    elif len(exp)==0:#直接修改单词
        curs.execute("update words set word='"+wd+"' where id="+str(id))
        conn.commit()
    else:#修改整个记录
        curs.execute("update words set expl='"+exp+"' where id="+str(id))
        conn.commit()
        curs.execute("update words set word='"+wd+"' where id="+str(id))
        conn.commit()
    conn.close()
def getRecent():#得到所有单词
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()
    #curs.execute("select * from words order by id desc limit 0,20")
    curs.execute("select * from words order by word desc")
    ls=curs.fetchall()
    conn.commit()
    conn.close()       
    return ls[:]  
def getMaxCount():#得到单词测试最低限
    maxcountdict=readconf.getConfDict()
    maxcount=int(maxcountdict["LimitCount"])
    return maxcount#通过测试的底线
def getPassNumber(maxline):#统计已通过测试的词汇
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()
    curs.execute("select count(*) from words where count>"+str(maxline))
    ls=curs.fetchall()
    conn.commit()
    conn.close()     
    if len(ls)!=0:
        return ls[0][0]
    else:
        return None
def checkError():#检查是不是所有的count都越界，是返回1
    maxcount=getMaxCount()
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()
    curs.execute("select min(count) from words")
    ls=curs.fetchall()
    conn.commit()
    conn.close()  
    if len(ls)!=0:
        if ls[0][0]>maxcount:
            return 1
        else:
            return 0
    else:
        return None
def checkCountExp(exp):#检查count是不是大于maxcount,是返回1
    maxcount=getMaxCount()
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()
    curs.execute("select count from words where expl='"+exp+"'")
    ls=curs.fetchall()
    conn.commit()
    conn.close()   
    if len(ls)!=0:
        if ls[0][0]>maxcount:
            return 1
        else:
            return 0    
    else:
        return None
def checkCount(strwd):#检查count是不是大于maxcount,是返回1
    maxcount=getMaxCount()
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()
    curs.execute("select count from words where word='"+strwd+"'")
    ls=curs.fetchall()
    conn.commit()
    conn.close()   
    if len(ls)!=0:
        if ls[0][0]>maxcount:
            return 1
        else:
            return 0
    else:
        return None
def addCount(wd):#增加正确计数
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()
    curs.execute("update words set count=count+1 where word='"+wd+"'")
    conn.commit()
    conn.close()      
def subCount(wd):#减少正确计数
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()
    curs.execute("update words set count=count-1 where word='"+wd+"'")
    conn.commit()
    conn.close()  
def getWord(exp):#返回（单词，序号）元组
    exp=exp.replace(',','@')
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()    
    curs.execute("select * from words where expl like+'%"+exp+"%'")
    ls=curs.fetchall()
    conn.commit()
    conn.close()    
    if len(ls)!=0:
        return (ls[0][1],ls[0][0]) 
    else:
        return (None,None)
def getExp(wd):#返回（释义，序号）元组
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()    
    curs.execute("select * from words where word='"+wd+"'")
    ls=curs.fetchall()
    conn.commit()
    conn.close()       
    if len(ls)!=0:
        return (ls[0][2],ls[0][0])     
    else:
        return (None,None)
def getDBLength():#返回数据库的总行数
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()
    curs.execute("select max(id) from words")
    ls=curs.fetchall()
    conn.commit()
    conn.close() 
    if len(ls)!=0:
        return ls[0][0] 
    else:
        return None
def existWord(wd):#存在返回1，不存在返回0
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()
    curs.execute("select * from words where word='"+wd+"'")
    ls=curs.fetchall()
    conn.commit()
    conn.close()    
    if len(ls)==0:
        return 0    
    else:
        return 1      